﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Net;

namespace UnityScripte
{
    class Program
    {
        public static string sever = "ftp://127.0.0.1:36/";
        public static DirectoryInfo maindirectories;
        public static FileInfo[] allfiles; 
        public static DirectoryInfo[] alldirectory;
        public static Stream requestStream;
        public static StreamReader sourceStream;
        public static FtpWebResponse response;
        public static FtpWebRequest request;

        public static string user = "user", password = "password";

        static void Main(string[] args)
        {
            maindirectories = new DirectoryInfo(AppDomain.CurrentDomain.BaseDirectory + "..\\..\\Scripte");

            UploadFiles();
            Console.ReadKey(true);
        }

        public static void UploadFiles()
        {
            string newFile;
            string newdirectory=""; 
            DirectoryInfo lastdirectory= new DirectoryInfo("c:\\"), nowdirectory = maindirectories;
            int index, directoryindex=0;
            bool done = false;

            while (!done)
            {
                allfiles = nowdirectory.GetFiles();

                for (int i = 0; i < allfiles.Length; i++)
                {
                    newFile = allfiles[i].Name;

                    if (!newFile.EndsWith(".cs") || allfiles[i].Attributes != FileAttributes.Archive) continue;

                    Uri uri = new Uri(sever + newdirectory + "/" + newFile);
                    request = (FtpWebRequest)WebRequest.CreateDefault(uri);
                    request.Method = WebRequestMethods.Ftp.UploadFile;
                    request.Credentials = new NetworkCredential(user, password);

                    sourceStream = new StreamReader(allfiles[i].FullName);
                    byte[] fileContents = Encoding.UTF8.GetBytes(sourceStream.ReadToEnd());
                    sourceStream.Close();
                    request.ContentLength = fileContents.Length;

                    requestStream = request.GetRequestStream();
                    requestStream.Flush();
                    requestStream.Write(fileContents, 0, fileContents.Length);
                    requestStream.Close();

                    response = (FtpWebResponse)request.GetResponse();

                    allfiles[i].Attributes = FileAttributes.Normal;
                    Console.WriteLine("Upload File Complete: {0}, status {1}", newdirectory + newFile, response.StatusDescription);

                    response.Close();
                }
                request = null;

                alldirectory = nowdirectory.GetDirectories();
                while (alldirectory.Length <= directoryindex)
                {
                    if (nowdirectory.FullName == maindirectories.Parent.FullName)
                    {
                        Console.WriteLine("Upload Complete");
                        return;
                    }
                    if (alldirectory.Length == 0 || alldirectory[alldirectory.Length - 1].FullName == lastdirectory.FullName)
                    {
                        lastdirectory = nowdirectory;
                        nowdirectory = nowdirectory.Parent;
                    }
                    else
                        directoryindex = 0;

                    alldirectory = nowdirectory.GetDirectories();
                    for (int i = 0; i < alldirectory.Length; i++)
                        if (alldirectory[i].FullName == lastdirectory.FullName)
                            directoryindex = i + 1;
                }
                nowdirectory = alldirectory[directoryindex];

                index = nowdirectory.FullName.LastIndexOf("UnityScripte\\Scripte");
                newdirectory = nowdirectory.FullName.Remove(0, index + 20);
                if (newdirectory.Length >= 2)
                    newdirectory = newdirectory.Remove(0, 1);
                   
                if (!isDicExists(newdirectory))
                {
                    try
                    {
                        Uri newD = new Uri(sever + newdirectory + "/");
                        request = (FtpWebRequest)WebRequest.Create(newD);
                        request.Method = WebRequestMethods.Ftp.MakeDirectory;
                        request.Credentials = new NetworkCredential(user, password);

                        response = (FtpWebResponse)request.GetResponse();
                        Console.WriteLine("Create Directory: {0} status: {1}", newdirectory, response.StatusDescription);
                        response.Close();
                    }
                    catch
                    {
                        ;
                    }
                }
            }
        }

        public static bool isDicExists(string isDicExists)
        {
            string NowDic = "";
            int sindex = isDicExists.LastIndexOf('/');
            if (sindex > 0)
                NowDic = isDicExists.Remove(sindex);
            List<string> alldic = getAllDicExists(NowDic);
            if (alldic == null) return false;

            for (int i = 0; i < alldic.Count; i++)
                if (alldic[i] == isDicExists)
                    return true;
            return false;
        }

        public static List<string> getAllDicExists(string NowDic)
        {
            List<string> directories = new List<string>();
            try {
                request = (FtpWebRequest)FtpWebRequest.Create(sever+NowDic+"/");
                request.Credentials = new NetworkCredential(user, password);
                request.Method = WebRequestMethods.Ftp.ListDirectory;

                response = (FtpWebResponse)request.GetResponse();
                StreamReader sr = new StreamReader(response.GetResponseStream());
                string line = String.Empty;
                while((line = sr.ReadLine()) != null) {
                    directories.Add(line);
                }
                response.Close();
                sr.Close();
            }
            catch
            {
                directories = null;
            }
            return directories;
        }
    }
}
